#include <stream.h>
#include <stdlib.h>
#include <plinda.h>
#include <timing.h>
#include <timer.h>
#include <stdio.h>
#include <unistd.h>
#include <malloc.h>
#include <fstream.h>
#include <string.h>


#ifndef linux
extern "C" int gethostname (char *,int); 
#endif


#include "W.h"

char dummy[20];

gid gidMe;
int next_trans = 0;

int real_main (int,char **,char **);
void zoom_ms (void);
void files_init (void);

int iScreenSizeX,iScreenSizeY,iDivideX,iDivideY,iMaxiter;
int iNumWorkers;
int iNumJobs;

int foo[1000];
  
double StartR=-1.76698666667;
double StartI=-1.276666665e-2;
double SizeR=0.0039;
double SizeI=0.0039;

int fGot1,fGot0;

int real_main (int argc,char *argv[],char *env[])
{

  long XE_key,XE_x,XE_y,XE_z; 
  long Zoom_1_x,Zoom_1_y,Zoom_2_x,Zoom_2_y;

  int fLeftButtonDown=0;
  int fPlottedBox=0;


bool recover = (_PLtemp = Tuple::create(9,0 ), _PLtemp->setFormal(0, TupleField::PLgid,(gid*)(&(gidMe))), _PLtemp->setFormal(1, TupleField::PLint,(int*)(&(iScreenSizeX))), _PLtemp->setFormal(2, TupleField::PLint,(int*)(&(iScreenSizeY))), _PLtemp->setFormal(3, TupleField::PLint,(int*)(&(iDivideX))), _PLtemp->setFormal(4, TupleField::PLint,(int*)(&(iDivideY))), _PLtemp->setFormal(5, TupleField::PLint,(int*)(&(iMaxiter))), _PLtemp->setFormal(6, TupleField::PLint,(int*)(&(iNumWorkers))), _PLtemp->setFormal(7, TupleField::PLint,(int*)(&(iNumJobs))), _PLtemp->setFormal(8, TupleField::PLint,(int*)(&(next_trans))), xrecover(_PLtemp)) ;


if(recover) {	

  cerr << "**  Restart from failure !\n";
}
  

if(next_trans == 0) {
  xstart;

  
  cout << "\nParameters ...\n";

  cout << "\nScreenSizeX: 600\n";
  iScreenSizeX=600;

  cout << "\niScreenSizeY: 600\n";
  iScreenSizeY=600;


  iDivideX=18;


  iDivideY=9;


  iMaxiter=128;

  cout << "\nEnter iNumWorkers: ";
  cin >> iNumWorkers;

  gidMe=create_group("ms1");


  (_PLtemp = Tuple::create(9,0 ), _PLtemp->setActual(0, TupleField::PLgid,(const gid)gidMe), _PLtemp->setActual(1, TupleField::PLint,(const int)iScreenSizeX), _PLtemp->setActual(2, TupleField::PLint,(const int)iScreenSizeY), _PLtemp->setActual(3, TupleField::PLint,(const int)iDivideX), _PLtemp->setActual(4, TupleField::PLint,(const int)iDivideY), _PLtemp->setActual(5, TupleField::PLint,(const int)iMaxiter), _PLtemp->setActual(6, TupleField::PLint,(const int)iNumWorkers), _PLtemp->setActual(7, TupleField::PLint,(const int)iNumJobs), _PLtemp->setActual(8, TupleField::PLint,(const int)++next_trans), xcommit(_PLtemp)) ;


}

  W_init (iScreenSizeX,iScreenSizeY,"MS-1 plot");

  BEGINTIMING;

  zoom_ms ();

  ENDTIMING;

  cout << "\n\n"<< TIMINGS << "," << (TIMINGMS-1000*TIMINGS) << "," << (TIMINGUS-1000*TIMINGMS) << " usec\n";
#if DEBUG_PRINT
  fout << "\n\n"<< TIMINGS << "," << (TIMINGMS-1000*TIMINGS) << "," << (TIMINGUS-1000*TIMINGMS) << " usec\n" << flush;
#endif


  fLeftButtonDown=0;
  fPlottedBox=0;
  while (1) {

    W_event(&XE_key,&XE_x,&XE_y,&XE_z);
    if (XE_key==RIGHT_MOUSE_BUTTON) {
      break;
    }
    if (XE_key==MIDDLE_MOUSE_BUTTON) {
      if (XE_z==255) {
	if (fLeftButtonDown) {
	  if (fPlottedBox) {
	    W_box(Zoom_1_x,Zoom_1_y,Zoom_2_x,Zoom_2_y);
	  }
	  fPlottedBox=1; 
	  Zoom_2_x=XE_x;
	  Zoom_2_y=XE_y;
	 
	  W_box(Zoom_1_x,Zoom_1_y,Zoom_2_x,Zoom_2_y);
	  W_sync();
	}
	else {
	  Zoom_1_x=XE_x;
	  Zoom_1_y=XE_y;
	  fLeftButtonDown=1;
	}
      }
      else {
	
	 
	W_box(Zoom_1_x,Zoom_1_y,Zoom_2_x,Zoom_2_y);
	W_sync();
	fLeftButtonDown=0;
	fPlottedBox=0;
      }
    }
    if (XE_z==255 && XE_key==LEFT_MOUSE_BUTTON) {
      
      cout << "New zoom co-oords...\n";
    }
  }

  W_destroy();
}

void zoom_ms (void)
{
  int x,y,i;
  int iDivideSizeX,iDivideSizeY;
  int iCornerX,iCornerY;

  iDivideSizeX=iScreenSizeX/iDivideX;
  iDivideSizeY=iScreenSizeY/iDivideY;

  int *piIters;
  piIters=(int *)(malloc(iDivideSizeX*iDivideSizeY*sizeof(int)));
  if (piIters==NULL) {
    cout << "\nError: master: cannot malloc piIters";
  }

if(next_trans == 1) {

  xstart;

  (_PLtemp = Tuple::create(10,0 + ((::strlen("global")+1) * sizeof(char)) ), _PLtemp->setActual(0, TupleField::PLchar,(const char*)"global",(::strlen("global") + 1)*sizeof(char)), _PLtemp->setActual(1, TupleField::PLint,(const int)iScreenSizeX), _PLtemp->setActual(2, TupleField::PLint,(const int)iScreenSizeY), _PLtemp->setActual(3, TupleField::PLint,(const int)iDivideX), _PLtemp->setActual(4, TupleField::PLint,(const int)iDivideY), _PLtemp->setActual(5, TupleField::PLint,(const int)iMaxiter), _PLtemp->setActual(6, TupleField::PLdouble,(const double)StartR), _PLtemp->setActual(7, TupleField::PLdouble,(const double)StartI), _PLtemp->setActual(8, TupleField::PLdouble,(const double)SizeR), _PLtemp->setActual(9, TupleField::PLdouble,(const double)SizeI), pl_out(gidMe, _PLtemp)) ;



  for (i=0; i<iNumWorkers; i++) {

    (_PLtemp = Tuple::create(2,0 + ((::strlen("wmandelbrot")+1) * sizeof(char)) ), _PLtemp->setActual(0, TupleField::PLchar,(const char*)"wmandelbrot",(::strlen("wmandelbrot") + 1)*sizeof(char)), _PLtemp->setActual(1, TupleField::PLgid,(const gid)gidMe), pl_proc_eval(_PLtemp)) ;
  }

  iNumJobs=0;
  for (x=0; x<iScreenSizeX; x += iDivideSizeX) {
    for (y=0; y<iScreenSizeY; y += iDivideSizeY) {

      (_PLtemp = Tuple::create(3,0 + ((::strlen("job")+1) * sizeof(char)) ), _PLtemp->setActual(0, TupleField::PLchar,(const char*)"job",(::strlen("job") + 1)*sizeof(char)), _PLtemp->setActual(1, TupleField::PLint,(const int)x), _PLtemp->setActual(2, TupleField::PLint,(const int)y), pl_out(gidMe, _PLtemp)) ;
      iNumJobs++;
    }
  } 


  (_PLtemp = Tuple::create(9,0 ), _PLtemp->setActual(0, TupleField::PLgid,(const gid)gidMe), _PLtemp->setActual(1, TupleField::PLint,(const int)iScreenSizeX), _PLtemp->setActual(2, TupleField::PLint,(const int)iScreenSizeY), _PLtemp->setActual(3, TupleField::PLint,(const int)iDivideX), _PLtemp->setActual(4, TupleField::PLint,(const int)iDivideY), _PLtemp->setActual(5, TupleField::PLint,(const int)iMaxiter), _PLtemp->setActual(6, TupleField::PLint,(const int)iNumWorkers), _PLtemp->setActual(7, TupleField::PLint,(const int)iNumJobs), _PLtemp->setActual(8, TupleField::PLint,(const int)++next_trans), xcommit(_PLtemp)) ;



}

if(next_trans == 2) {

  xstart;

  while (iNumJobs>0) {

    (_PLtemp = Tuple::create(4,0 + ((::strlen("done")+1) * sizeof(char)) ), _PLtemp->setActual(0, TupleField::PLchar,(const char*)"done",(::strlen("done") + 1)*sizeof(char)), _PLtemp->setFormal(1, TupleField::PLint,(int*)(&(iCornerX))), _PLtemp->setFormal(2, TupleField::PLint,(int*)(&(iCornerY))), _PLtemp->setFormal(3, TupleField::PLint,(int*)(piIters),iDivideSizeX*iDivideSizeY), pl_in(gidMe, _PLtemp)) ;

    for (y=0; y<iDivideSizeY; y++) {
      for (x=0; x<iDivideSizeX; x++) {
	if ((piIters[y*iDivideSizeX+x]&1)==1) {
	  W_setpixel(iCornerX+x,iCornerY+y);
	}
      }
    }
    W_sync();

    iNumJobs--;
  }

  
  for (i=0; i<iNumWorkers; i++) {

    (_PLtemp = Tuple::create(3,0 + ((::strlen("job")+1) * sizeof(char)) ), _PLtemp->setActual(0, TupleField::PLchar,(const char*)"job",(::strlen("job") + 1)*sizeof(char)), _PLtemp->setActual(1, TupleField::PLint,(const int)-1), _PLtemp->setActual(2, TupleField::PLint,(const int)-1), pl_out(gidMe, _PLtemp)) ;

  }


  (_PLtemp = Tuple::create(9,0 ), _PLtemp->setActual(0, TupleField::PLgid,(const gid)gidMe), _PLtemp->setActual(1, TupleField::PLint,(const int)iScreenSizeX), _PLtemp->setActual(2, TupleField::PLint,(const int)iScreenSizeY), _PLtemp->setActual(3, TupleField::PLint,(const int)iDivideX), _PLtemp->setActual(4, TupleField::PLint,(const int)iDivideY), _PLtemp->setActual(5, TupleField::PLint,(const int)iMaxiter), _PLtemp->setActual(6, TupleField::PLint,(const int)iNumWorkers), _PLtemp->setActual(7, TupleField::PLint,(const int)iNumJobs), _PLtemp->setActual(8, TupleField::PLint,(const int)++next_trans), xcommit(_PLtemp)) ;


}

}

#if 0
void files_init (void)
{
  FILE *init_file;

  chdir ("plinda_bin");

  init_file=fopen("Init","r+t");

  if (init_file==NULL) {
    cout << "\nCant open ~/PLinda/ms1/Init.";
    cin >> dummy;
  }

  fscanf (init_file,"%d",&iScreenSizeX);
  fscanf (init_file,"%d",&iScreenSizeY);
  fscanf (init_file,"%d",&iDivideX);
  fscanf (init_file,"%d",&iDivideY);
  fscanf (init_file,"%d",&iMaxiter);

  fclose (init_file);

  return;

}
#endif
