#include <plinda.h>
#include <stream.h>
#include <stdlib.h>
#include <malloc.h>
#include <stdio.h>
#include <fstream.h>
#include <string.h>

extern "C" int gethostname (char *,int); 

#define ITERS_NULL (-1)

gid gidMe;

int iMaxiter;
double StartR,StartI,SizeR,SizeI;

char *pfBoundary;
int *piIters;

  int iScreenSizeX,iScreenSizeY,iDivideX,iDivideY;
  int iStartX,iStartY;
  int iCurrX,iCurrY;

  int iDivideSizeX,iDivideSizeY;

  int iBoundaryIters;

void StartScanning (void);
int iIterateCoord (int iCurrX,int iCurrY);
int iIterate (double cr,double ci);


int real_main (int argc,char *argv[],char *env[])
{

  char name[100];
  (_PLtemp = Tuple::create(2,0 ), _PLtemp->setFormal(0, TupleField::PLchar,(char*)(name),100), _PLtemp->setFormal(1, TupleField::PLgid,(gid*)(&(gidMe))), pl_arg_rdp(_PLtemp)) ;
  (_PLtemp = Tuple::create(10,0 + ((::strlen("global")+1) * sizeof(char)) ), _PLtemp->setActual(0, TupleField::PLchar,(const char*)"global",(::strlen("global") + 1)*sizeof(char)), _PLtemp->setFormal(1, TupleField::PLint,(int*)(&(iScreenSizeX))), _PLtemp->setFormal(2, TupleField::PLint,(int*)(&(iScreenSizeY))), _PLtemp->setFormal(3, TupleField::PLint,(int*)(&(iDivideX))), _PLtemp->setFormal(4, TupleField::PLint,(int*)(&(iDivideY))), _PLtemp->setFormal(5, TupleField::PLint,(int*)(&(iMaxiter))), _PLtemp->setFormal(6, TupleField::PLdouble,(double*)(&(StartR))), _PLtemp->setFormal(7, TupleField::PLdouble,(double*)(&(StartI))), _PLtemp->setFormal(8, TupleField::PLdouble,(double*)(&(SizeR))), _PLtemp->setFormal(9, TupleField::PLdouble,(double*)(&(SizeI))), pl_rd(gidMe, _PLtemp)) ;



  iDivideSizeX=iScreenSizeX/iDivideX;
  iDivideSizeY=iScreenSizeY/iDivideY;

    pfBoundary=(char *)(malloc(iDivideSizeX*iDivideSizeY*sizeof(char)));
    piIters=(int *)(malloc(iDivideSizeX*iDivideSizeY*sizeof(int)));
    if (piIters==NULL || pfBoundary==NULL) {
      cerr << "Error: Worker: couldn't allocate memory for local variables\n\n"; 
      cerr.flush();
      exit(1);
    }

  while (1) {

    xstart;

    (_PLtemp = Tuple::create(3,0 + ((::strlen("job")+1) * sizeof(char)) ), _PLtemp->setActual(0, TupleField::PLchar,(const char*)"job",(::strlen("job") + 1)*sizeof(char)), _PLtemp->setFormal(1, TupleField::PLint,(int*)(&(iStartX))), _PLtemp->setFormal(2, TupleField::PLint,(int*)(&(iStartY))), pl_in(gidMe, _PLtemp)) ;

    if (iStartX==-1) {
      

      xcommit(NULL);
      break;
    }

    StartScanning ();

      xcommit(NULL);

  }




  return 1;
}

void StartScanning (void)
{

  int iCurrX,iCurrY;

  for (iCurrY=0; iCurrY<iDivideSizeY; iCurrY++) {
    for (iCurrX=0; iCurrX<iDivideSizeX; iCurrX++) {
      piIters[iCurrY*iDivideSizeX+iCurrX]=iIterateCoord (iCurrX,iCurrY);
    }
  }
  (_PLtemp = Tuple::create(4,0 + ((::strlen("done")+1) * sizeof(char)) + sizeof(int) * iDivideSizeX*iDivideSizeY ), _PLtemp->setActual(0, TupleField::PLchar,(const char*)"done",(::strlen("done") + 1)*sizeof(char)), _PLtemp->setActual(1, TupleField::PLint,(const int)iStartX), _PLtemp->setActual(2, TupleField::PLint,(const int)iStartY), _PLtemp->setActual(3, TupleField::PLint,(const int*)piIters,iDivideSizeX*iDivideSizeY), pl_out(gidMe, _PLtemp)) ;

}

int iIterate (double cr,double ci)



{
  int iCurriter;
  double zr,zi,tzr;

  iCurriter=0;
  zr=0.0;
  zi=0.0;

  while (iCurriter<iMaxiter && (zr*zr+zi*zi)<4.0) {
    tzr=(zr+zi)*(zr-zi)+cr;
    zi=2.0*zr*zi+ci;
    zr=tzr;
    iCurriter++;
  }

  return (iCurriter);
}

int iIterateCoord (int iCurrX,int iCurrY)








{
  double cr,ci;

  cr=(double)(iStartX+iCurrX)/(double)(iScreenSizeX)*SizeR+StartR;
  ci=(double)(iStartY+iCurrY)/(double)(iScreenSizeY)*SizeI+StartI;

  return (iIterate(cr,ci));
}
