
#ifndef _PLINDA_FN_H_
#define _PLINDA_FN_H_

extern void out_slavedone(int my_id,int num_done, gid g);
extern void out_counter(int pass,int level,int done,int todo, gid g);
extern void out_job(int lev,int row, gid g);
extern void out_complex_array(char* str, int level,int row,
			      s_complex* complex_array, gid g);
extern void out_particles(int row, int num_particles, 
			  s_particle* particles, gid g);
extern void in_counter(int &pass,int &level, int &num_done, 
		       int &num_todo, gid g);
extern void in_job01(int cur_level, int &row, gid g);
extern void in_job11(int &cur_level, int &row, gid g);
extern void in_phi(int level,int row,s_complex *phi_val, gid g);
extern void in_particles(int row,int &num_particles,
			 s_particle* particles, gid g);
extern void in_slavedone(int &my_id, int &num_done, gid g);
extern void rd_particles(int row,int &num_particles,
			 s_particle* particles, gid g);
extern void rd_complex_array(char* str, int level, int row, 
			     s_complex *complex_array, gid g);
extern int argument_rdp_params(int &my_id, int &grain_size, gid& g);

extern int recover_master_state(gid &g, int &grain_size, int &num_workers, 
			         char* pfile,int&   next_trans);
extern int recover_worker_state(int &pass,int& start_row,int& level,
				 int& my_id, int& val,int& grain_size,
				 gid&  g,int& next_trans, int& num_jobs_done);

extern void in_slave_started(int &my_id, gid g);
extern void rd_slave_started(int i, gid g);
extern void out_slave_started(int my_id, gid g);

#endif  /* _PLINDA_FN_H_ */
