#ifndef ANALYZE_EMIT_PLINDA
#define ANALYZE_EMIT_PLINDA
#include "context.h"
#include "SymTable.h"

	char * Check_for_GID(SymTable * Sym_Table, CONTEXT * c);
	int Is_Tuple_Space_Empty(CONTEXT * c);
	void Obtain_ARGRDP_Assignment_and_Emit(CONTEXT * c, FILE * plinda);

	int Check_for_Tuple_Space_Absence(int , CONTEXT * c);
	int Emit_Pl_Out(CONTEXT * c, FILE * a , SymTable * b);
	int Emit_Pl_Command(int a, CONTEXT * b, FILE * c, SymTable * d );
	int TupleLength(CONTEXT * c);
	int Collect_PLinda_TupleSpace(CONTEXT * b, FILE * c, SymTable * d);

	void Emit_GID(char[], int , FILE *);

	int Emit_PLinda(char[], FILE * , CONTEXT * c, SymTable * );

	int Constants_Emit(char[], FILE * );
	int Check_if_End_of_Line(CONTEXT * c);
	int Legal_PLinda_Char(char a, int b);
	char * Get_Array_Length(char line[80], int index);

	char * Fetch_Pure_Var_Name(char tuple_space_str_arg[80]);
	char * Fetch_Var_Name_and_Tuple_Space_Arg(char tuple_space_str_arg[80]);
	int Fetch_lvalue_Spec(char tuple_space_str_arg[80]);
	void Fetch_Type_and_Size(SymTable * , char var_name[80], 
					int * , int *, CONTEXT * c);
	void Analyze_for_Type_and_Size_Emittance(char * array_size,
			int , char var_name[80], int , FILE * , CONTEXT * c);
	int Emit_According_to_Var_Type(int , char name[80], int , 
				FILE * , CONTEXT * c); 

	int Emit_PLinda_based_upon_Type(char tuple_space_str_arg[80], FILE * , 
				CONTEXT * c, SymTable * symT);


#endif
