

//#ifdef  __GNUC__
//extern "C" {
//        int gettimeofday(struct timeval *, struct timezone *);
//}
//#endif

static timeval		timeBefore;

int stampTime(timeval &tp) {
        return( gettimeofday(&tp, (struct timezone *)NULL) );
}

// returns time in tenth of a second
time_t diffTime(struct timeval &t1 , struct timeval &t2) {
        return((1000000*(t1.tv_sec - t2.tv_sec) + (t1.tv_usec - t2.tv_usec))/100000);
}

void start(char *s) {
	cout << s << ::flush;
	stampTime(timeBefore);
}

void done() {
	timeval		timeAfter;
	stampTime(timeAfter);
	time_t	totalTime = diffTime(timeAfter, timeBefore);
	cout << " done in " << totalTime/10. << " seconds." << endl;
}

