
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "param.h"
#include "gen.h"
#include "global.h"


FILE *fout, *fopen();
int  i,k, j,delp, p;
float side= 0.0;
float f1=0.0, f2=0.0, q=0.0;

main(argc, argv)
int argc; char** argv;
{
    if (argc!=2) {
	printf("Give the name of the file in which the data should go.\n");
	exit(1);
    }
    fout = fopen(*(argv+1), "w");
    srand((unsigned int)(time(NULL)/2));    /*initialize the seed*/
    p =0;
    side = RootBoxSide/dim[LeafLevel];
    for(i=0; i<dim[LeafLevel]; i++)
      for(j=0; j<dim[LeafLevel]; j++){
	delp = rand()%ParticleDensity + 1; 
	p += delp;
	for(k=0; k<delp; k++){
	    f1 = (1.0/(rand()%50+1) + i)*side;
	    f2 = (1.0/(rand()%50+1) + j)*side;
	    q = rand()%ChargeScale + 1.0/(rand()%10+1);
	    fprintf(fout, "%d %d %f %f %f\n", i,j, f1, f2, q);
	}
      }

   printf("No of particles = %d \n", p);
   fclose(fout);

}
