


 
#include <plinda.h>
#include <iostream.h>
#include "ds.h"
#include "complex.h"

extern "C" {
#include <stdlib.h>
}




void
out_slavedone(int my_id, int num_done, gid g){

    (_PLtemp = Tuple::create(3,0 + ((::strlen("slave_done")+1) * sizeof(char)) ), _PLtemp->setActual(0, TupleField::PLchar,(const char*)"slave_done",(::strlen("slave_done") + 1)*sizeof(char)), _PLtemp->setActual(1, TupleField::PLint,(const int)my_id), _PLtemp->setActual(2, TupleField::PLint,(const int)num_done), pl_out(g, _PLtemp)) ;
}



void
out_slave_started(int my_id, gid g){

    (_PLtemp = Tuple::create(2,0 + ((::strlen("slave_started")+1) * sizeof(char)) ), _PLtemp->setActual(0, TupleField::PLchar,(const char*)"slave_started",(::strlen("slave_started") + 1)*sizeof(char)), _PLtemp->setActual(1, TupleField::PLint,(const int)my_id), pl_out(g, _PLtemp)) ;

}




void
out_counter(int pass,int level,int num_done,int num_todo, gid g){

    (_PLtemp = Tuple::create(5,0 + ((::strlen("job_counter")+1) * sizeof(char)) ), _PLtemp->setActual(0, TupleField::PLchar,(const char*)"job_counter",(::strlen("job_counter") + 1)*sizeof(char)), _PLtemp->setActual(1, TupleField::PLint,(const int)pass), _PLtemp->setActual(2, TupleField::PLint,(const int)level), _PLtemp->setActual(3, TupleField::PLint,(const int)num_done), _PLtemp->setActual(4, TupleField::PLint,(const int)num_todo), pl_out(g, _PLtemp)) ;
}




void
out_job(int level,int row, gid g){ 

    (_PLtemp = Tuple::create(3,0 + ((::strlen("job")+1) * sizeof(char)) ), _PLtemp->setActual(0, TupleField::PLchar,(const char*)"job",(::strlen("job") + 1)*sizeof(char)), _PLtemp->setActual(1, TupleField::PLint,(const int)level), _PLtemp->setActual(2, TupleField::PLint,(const int)row), pl_out(g, _PLtemp)) ;
}






void
out_complex_array(char* str, int level,int row,
		  s_complex* complex_array, gid g){

    (_PLtemp = Tuple::create(4,0 + (::strlen(str) +1)* sizeof(char) + sizeof(s_complex) * (MaxNumRowCplx) ), _PLtemp->setActual(0, TupleField::PLchar,(const char*)str,::strlen(str)+1), _PLtemp->setActual(1, TupleField::PLint,(const int)level), _PLtemp->setActual(2, TupleField::PLint,(const int)row), _PLtemp->setActual(3, TupleField::PLstruct,(const void*)complex_array,sizeof(s_complex),MaxNumRowCplx), pl_out(g, _PLtemp)) ;

}



void
out_particles(int row, int num_particles, s_particle* particles, gid g){

(_PLtemp = Tuple::create(4,0 + ((::strlen("particles")+1) * sizeof(char)) + sizeof(s_particle) * (MaxNumRowPar) ), _PLtemp->setActual(0, TupleField::PLchar,(const char*)"particles",(::strlen("particles") + 1)*sizeof(char)), _PLtemp->setActual(1, TupleField::PLint,(const int)row), _PLtemp->setActual(2, TupleField::PLint,(const int)num_particles), _PLtemp->setActual(3, TupleField::PLstruct,(const void*)particles,sizeof(s_particle),MaxNumRowPar), pl_out(g, _PLtemp)) ;

}



void
in_counter(int &pass,int &level, int &num_done, int &num_todo, gid g){

    (_PLtemp = Tuple::create(5,0 + ((::strlen("job_counter")+1) * sizeof(char)) ), _PLtemp->setActual(0, TupleField::PLchar,(const char*)"job_counter",(::strlen("job_counter") + 1)*sizeof(char)), _PLtemp->setFormal(1, TupleField::PLint,(int*)(&(pass))), _PLtemp->setFormal(2, TupleField::PLint,(int*)(&(level))), _PLtemp->setFormal(3, TupleField::PLint,(int*)(&(num_done))), _PLtemp->setFormal(4, TupleField::PLint,(int*)(&(num_todo))), pl_in(g, _PLtemp)) ;

}



void
in_job01(int cur_level, int &row, gid g){

    (_PLtemp = Tuple::create(3,0 + ((::strlen("job")+1) * sizeof(char)) ), _PLtemp->setActual(0, TupleField::PLchar,(const char*)"job",(::strlen("job") + 1)*sizeof(char)), _PLtemp->setActual(1, TupleField::PLint,(const int)cur_level), _PLtemp->setFormal(2, TupleField::PLint,(int*)(&(row))), pl_in(g, _PLtemp)) ;
}



void
in_job11(int &cur_level, int &row, gid g){

    (_PLtemp = Tuple::create(3,0 + ((::strlen("job")+1) * sizeof(char)) ), _PLtemp->setActual(0, TupleField::PLchar,(const char*)"job",(::strlen("job") + 1)*sizeof(char)), _PLtemp->setFormal(1, TupleField::PLint,(int*)(&(cur_level))), _PLtemp->setFormal(2, TupleField::PLint,(int*)(&(row))), pl_in(g, _PLtemp)) ;
}




void
in_phi(int level, int row, s_complex *phi_val, gid g){

    (_PLtemp = Tuple::create(4,0 + ((::strlen("phi")+1) * sizeof(char)) ), _PLtemp->setActual(0, TupleField::PLchar,(const char*)"phi",(::strlen("phi") + 1)*sizeof(char)), _PLtemp->setActual(1, TupleField::PLint,(const int)level), _PLtemp->setActual(2, TupleField::PLint,(const int)row), _PLtemp->setFormal(3, TupleField::PLstruct,(void*)(phi_val),sizeof(s_complex),MaxNumRowCplx), pl_in(g, _PLtemp)) ;
}




void
in_particles(int row,int &num_particles,s_particle *particles, gid g){

    (_PLtemp = Tuple::create(4,0 + ((::strlen("particles")+1) * sizeof(char)) ), _PLtemp->setActual(0, TupleField::PLchar,(const char*)"particles",(::strlen("particles") + 1)*sizeof(char)), _PLtemp->setActual(1, TupleField::PLint,(const int)row), _PLtemp->setFormal(2, TupleField::PLint,(int*)(&(num_particles))), _PLtemp->setFormal(3, TupleField::PLstruct,(void*)(particles),sizeof(s_particle),MaxNumRowPar), pl_in(g, _PLtemp)) ;

}



void
in_slavedone(int &my_id, int &num_done, gid g) {

    (_PLtemp = Tuple::create(3,0 + ((::strlen("slave_done")+1) * sizeof(char)) ), _PLtemp->setActual(0, TupleField::PLchar,(const char*)"slave_done",(::strlen("slave_done") + 1)*sizeof(char)), _PLtemp->setFormal(1, TupleField::PLint,(int*)(&(my_id))), _PLtemp->setFormal(2, TupleField::PLint,(int*)(&(num_done))), pl_in(g, _PLtemp)) ;
 }



void
in_slave_started(int &my_id, gid g) {

    (_PLtemp = Tuple::create(2,0 + ((::strlen("slave_started")+1) * sizeof(char)) ), _PLtemp->setActual(0, TupleField::PLchar,(const char*)"slave_started",(::strlen("slave_started") + 1)*sizeof(char)), _PLtemp->setFormal(1, TupleField::PLint,(int*)(&(my_id))), pl_in(g, _PLtemp)) ;

}




void
rd_slave_started(int i, gid g) {

    (_PLtemp = Tuple::create(2,0 + ((::strlen("slave_started")+1) * sizeof(char)) ), _PLtemp->setActual(0, TupleField::PLchar,(const char*)"slave_started",(::strlen("slave_started") + 1)*sizeof(char)), _PLtemp->setActual(1, TupleField::PLint,(const int)i), pl_rd(g, _PLtemp)) ;
}



void
rd_particles(int row,int &num_particles,s_particle* particles, gid g){

    (_PLtemp = Tuple::create(4,0 + ((::strlen("particles")+1) * sizeof(char)) ), _PLtemp->setActual(0, TupleField::PLchar,(const char*)"particles",(::strlen("particles") + 1)*sizeof(char)), _PLtemp->setActual(1, TupleField::PLint,(const int)row), _PLtemp->setFormal(2, TupleField::PLint,(int*)(&(num_particles))), _PLtemp->setFormal(3, TupleField::PLstruct,(void*)(particles),sizeof(s_particle),MaxNumRowPar), pl_rd(g, _PLtemp)) ;

}



void
rd_complex_array(char* str, int level, int row, 
		 s_complex *complex_array, gid g){

    (_PLtemp = Tuple::create(4,0 + (::strlen(str) +1)* sizeof(char) ), _PLtemp->setActual(0, TupleField::PLchar,(const char*)str,::strlen(str)+1), _PLtemp->setActual(1, TupleField::PLint,(const int)level), _PLtemp->setActual(2, TupleField::PLint,(const int)row), _PLtemp->setFormal(3, TupleField::PLstruct,(void*)(complex_array),sizeof(s_complex),MaxNumRowCplx), pl_rd(g, _PLtemp)) ;


}





int
argument_rdp_params(int &my_id, int &grain_size, gid& g)
{
    char name[200];

    return (_PLtemp = Tuple::create(4,0 ), _PLtemp->setFormal(0, TupleField::PLchar,(char*)(name),200), _PLtemp->setFormal(1, TupleField::PLint,(int*)(&(my_id))), _PLtemp->setFormal(2, TupleField::PLint,(int*)(&(grain_size))), _PLtemp->setFormal(3, TupleField::PLgid,(gid*)(&(g))), pl_arg_rdp(_PLtemp)) ;

}


int 
recover_master_state(gid &g, int &grain_size, int &num_workers, 
		     char* pfile,int&   next_trans) { 

   return (_PLtemp = Tuple::create(5,0 ), _PLtemp->setFormal(0, TupleField::PLgid,(gid*)(&(g))), _PLtemp->setFormal(1, TupleField::PLint,(int*)(&(grain_size))), _PLtemp->setFormal(2, TupleField::PLint,(int*)(&(num_workers))), _PLtemp->setFormal(3, TupleField::PLchar,(char*)(pfile),60), _PLtemp->setFormal(4, TupleField::PLint,(int*)(&(next_trans))), xrecover(_PLtemp)) ;

}


int
recover_worker_state(int &pass,int& start_row,int& level,int& my_id, 
		     int& val,int& grain_size,gid&  g,int& next_trans,
		     int& num_jobs_done){

  return (_PLtemp = Tuple::create(10,0 + ((::strlen("slave_state")+1) * sizeof(char)) ), _PLtemp->setActual(0, TupleField::PLchar,(const char*)"slave_state",(::strlen("slave_state") + 1)*sizeof(char)), _PLtemp->setFormal(1, TupleField::PLint,(int*)(&(pass))), _PLtemp->setFormal(2, TupleField::PLint,(int*)(&(start_row))), _PLtemp->setFormal(3, TupleField::PLint,(int*)(&(level))), _PLtemp->setFormal(4, TupleField::PLint,(int*)(&(my_id))), _PLtemp->setFormal(5, TupleField::PLint,(int*)(&(val))), _PLtemp->setFormal(6, TupleField::PLint,(int*)(&(grain_size))), _PLtemp->setFormal(7, TupleField::PLgid,(gid*)(&(g))), _PLtemp->setFormal(8, TupleField::PLint,(int*)(&(next_trans))), _PLtemp->setFormal(9, TupleField::PLint,(int*)(&(num_jobs_done))), xrecover(_PLtemp)) ;


}








