/**********
File:		y.tab.h
Purpose:	Define the constants for keywords on which
		the lexer/parser takes action corresponding to the 
		keyword.
***********/

/***
Fortran Keywords
***/
#define DATA 1		/** Need? **/
#define REAL 2 
#define INTEGER 3
#define CHARACTER 4
#define COMPLEX 5 	/** Ignore this one ?? **/
#define DOUBLE 6 
#define LOGICAL 8 	/** What to do with this one ?? **/
#define IMPLICIT 9 
#define COMMON 10 
#define PARAMETER 11 	/** Need? **/
#define SUBROUTINE 12 
#define DIMENSION 13
#define INCLUDE 14 


/***
PLinda Keywords
***/
#define PLINDA 15	/** Not a keyword - just the beginning of 
				PLINDA keywords **/ 
#define GID 15		
#define PROC_EVAL 16
#define PL_OUT 17
#define PL_IN 18
#define PL_INP 19
#define PL_RD 20
#define PL_RDP 21
#define XSTART 22
#define XCOMMIT 23
#define ARG_RDP 24
#define XRECOVER 25
#define CREATE_GROUP 26
#define DESTROY_GROUP 27

#define PRINT 99
