// This may look like C code, but it is really -*- C++ -*-
//
// File:        Predictor.h
// Description:	predicts expected completion time of ft methods
// Created:  
// Author:      Peter Wyckoff
// Mail:        wyckoff@cs.nyu.edu
//
#ifndef _PREDICTOR_H_
#define _PREDICTOR_H_

double commitConsistentTime(double secs,int c, int loop, double alpha);


double messageReplayTime(double secs,int c, int loop, unsigned  i,
			 double alpha,int rdsNum,int rdsLength,
			 int outsNum,int outsLength);
			      
double triggeredTime(double compute_time,int commit_size, 		     
		     int repeat, unsigned  interval, double alpha,
		     int numProcs, double totContinuations );

#endif
